
c===========================================================================
       subroutine bathinterp(auxij,xim,xcell,xip,yjm,ycell,yjp,
     &                    xxlow,yylow,dxx,dyy,mxx,myy,zz,interp)
c===========================================================================

c     bathinterp reaverages topography resetting the auxij grid cell

      implicit none

      integer mxx,myy

      logical interp

      double precision zz(1:mxx,1:myy)

      double precision auxij,xim,xcell,xip,yjm,ycell,yjp,dx,dy
      double precision dxx,dyy,dxxii,dyyjj,xiim,xiip,yjjm,yjjp
      double precision slopex0,slopexf,slopey
      double precision auxy0,auxyf,deltax,deltay
      double precision xxii0,xxiif,yyjj0,yyjjf
      double precision auxc,area,wsum,capacy,capacyy,pi
      double precision xxlow,yylow,yyhi,xxhi,yjjc,xiic

      integer jjstart,jjend,iistart,iiend,jj,ii,mm,ii0,jj0,iif,jjf
      integer jj0z,jjfz

      integer mcapa

      common /latlongrid/ mcapa

       pi=3.14159265359d0

       dx=xip-xim
       dy=yjp-yjm

       xxhi=xxlow+mxx*dxx
       yyhi=yylow+myy*dyy
	
C========WARN IF CALLED INCORRECTLY==========
	if ((xim-xxlow).lt.-1.d-8.or.(xip-xxhi).gt.1.d-8) then
	   write(*,*) 'BATHINTERP: Called incorrectly'
	   write(*,*) 'xim,xxlow,xip,xxhi',xim,xxlow,xip,xxhi
        endif
	if ((yjm-yylow).lt.-1.d-8.or.(yjp-yyhi).gt.1.d-8) then
	   write(*,*) 'BATHINTERP: Called incorrectly'
	   write(*,*) 'yjm,yylow,yjp,yyhi',yjm,yylow,yjp,yyhi
	endif

	if ((xim-xxlow).lt.0.d0.or.(xip-xxhi).gt.0.d0) then
	      xim=dmax1(xxlow,xim)
              xip=dmin1(xxhi,xip)
        endif
              
	if ((yjm-yylow).lt.0.d0.or.(yjp-yyhi).gt.0.d0) then
	   yjm=dmax1(yylow,yjm)
	   yjp=dmin1(yyhi,yjp)
	endif
c=========================================

	if (mcapa.gt.0) then
           capacy=dabs(cos((pi/180.d0)*ycell))
        else
           capacy=1.d0
        endif

c=======figure out which bathymetry cells overlay the y-computational row===

      jjstart=myy
      jj0=1
      jjend=0

      do jj=1,myy
	    yjjc=yylow + (jj-.5d0)*dyy
	    yjjm=yylow + (jj-1.d0)*dyy
	    yjjp=yylow + (jj)*dyy

	    if (ycell.ge.yjjc.and.ycell.lt.yjjc+dyy) then
	          jj0=jj
	    endif

            if (yjjm.le.yjm.and.yjjp.gt.yjm) then
               jjstart=jj
            endif

            if (yjjm.lt.yjp.and.yjjp.ge.yjp) then
               jjend=jj
            endif

	    if (yjjm.gt.yjp) then
	     go to 22
	    endif

      enddo

 22   continue

c============================================================================

c========figure out which bathymetry cells overlay the x-computational column
      iistart=mxx
      ii0=1
      iiend=0

      do ii=1,mxx
	    xiic=xxlow + (ii-.5d0)*dxx
	    xiim=xxlow + (ii-1.d0)*dxx
	    xiip=xxlow + (ii)*dxx

	    if (xcell.ge.xiic.and.xcell.lt.xiic+dxx) then
	       ii0=ii
	    endif

            if (xiim.le.xim.and.xiip.gt.xim) then
                iistart=ii
            endif

            if (xiim.lt.xip.and.xiip.ge.xip) then
                iiend=ii
            endif

	    if (xiim.gt.xip) then
	        go to 24
	    endif
      enddo

 24   continue
c===========================================================================

c======== if grid cell is smaller than bathymetry interpolate===============
      if (iistart.le.iiend.and.jjstart.le.jjend) then

      if (dxx.gt.dx.and.dyy.gt.dy.and.interp) then

         if (ii0.eq.mxx) then
	    ii0=mxx-1
         endif

	 if (jj0.eq.myy) then
	     jj0=myy-1
	 endif

         iif=ii0+1
         jjf=jj0+1

	 yyjj0=yylow + (jj0-.5d0)*dyy
         xxii0=xxlow + (ii0-.5d0)*dxx

	 deltax=xcell-xxii0
	 deltay=ycell-yyjj0

         jjfz=myy-jjf+1
         jj0z=myy-jj0+1

	 slopex0=(zz(iif,jj0z)-zz(ii0,jj0z))/dxx
         slopexf=(zz(iif,jjfz)-zz(ii0,jjfz))/dxx

         auxy0 = zz(ii0,jj0z) + slopex0*deltax
         auxyf = zz(ii0,jjfz) + slopexf*deltax

         slopey= (auxyf-auxy0)/dyy

	 auxij = auxij + auxy0 + slopey*deltay

c=otherwise average the topography cells onto the computational grid cell===
c==using capacity averaging=================================================
      else
      	    area=0.d0
	    wsum=0.d0
            do jj=jjstart,jjend

	       yjjc=yylow + (jj-.5d0)*dyy
	       yjjm=yylow + (jj-1.d0)*dyy
	       yjjp=yylow + (jj)*dyy
               dyyjj=min(yjjp,yjp)-max(yjm,yjjm)

	       capacyy=dabs(cos((pi/180)*yjjc))

               do ii=iistart,iiend

	    	  xiic=xxlow + (ii-.5d0)*dxx
	    	  xiim=xxlow + (ii-1.d0)*dxx
	    	  xiip=xxlow + (ii)*dxx
                  dxxii=min(xiip,xip)-max(xim,xiim)
                  if (dxxii.lt.0.d0) then
                     write(*,*) 'BATHINTERP: Bathymetry Error'
                  endif

                  if (dyyjj.lt.0.d0) then
                     write(*,*) 'BATHINTPERP:Bathymetry Error'
                  endif
		  area=area+dxxii*dyyjj
		  wsum=wsum + zz(ii,myy-jj+1)*dxxii*dyyjj*capacyy
               enddo
            enddo
	    auxij = auxij + wsum/(area*capacy)
	endif
	else
	    write(*,*) 'BATHINTERP: Error:jjstart,jjend',jjstart,jjend
	endif

       return
       end
