c
c ------------------------------------------------------------------
c
      subroutine filval(val,mitot,mjtot,hx,hy,lev,time,
     1                  valc,auxc,mic,mjc,
     2                  xleft,xright,ybot,ytop,nvar,
     3                  mptr,ilo,ihi,jlo,jhi,aux,naux)
 
      implicit double precision (a-h,o-z)
      common /tolerance/ depthtolerance

      include "call.i"

      dimension   val(mitot,mjtot,nvar), valc(mic,mjc,nvar)
      dimension   aux(mitot,mjtot,nvar), auxc(mic,mjc,nvar)
      dimension   dudx(max1d), dudy(max1d)

      dimension coarseval(9,3)

      logical velocityflag,dryflag

c
c :::::::::::::::::::::::::::::: FILVAL ::::::::::::::::::::::::::
c
c create and fill coarser (lev-1) patch with one extra coarse cell all
c around, plus the ghost cells . will interpolate from this patch to grid mptr 
c without needing special boundary code. 
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

c     # indext into eta array for surface values:
      iaddeta(i,j) = loceta + i-1 + mic*(j-1)

      levc    = lev - 1
      lratiox = intratx(levc)
      lratioy = intraty(levc)
      hxcrse  = hx*lratiox
      hycrse  = hy*lratioy
      xl      = xleft  - hxcrse
      xr      = xright + hxcrse
      yb      = ybot   - hycrse
      yt      = ytop   + hycrse
c     set integer indices for coarser patch enlarged by 1 cell 
c     (can stick out of domain). proper nesting will insure this one
c     call is sufficient.
      iclo   = ilo/lratiox - 1
      jclo   = jlo/lratioy - 1
      ichi   = (ihi+1)/lratiox - 1 + 1
      jchi   = (jhi+1)/lratioy - 1 + 1
      ng     = 0

c    :::  mcapa  is the capacity function index

      if (naux .eq. 0) then
c     if (mcapa .eq. 0) then
        if (xperdom .or. yperdom) then
          call preintcopy(valc,mic,mjc,nvar,iclo,ichi,jclo,jchi,levc)
        else
          call intcopy(valc,mic,mjc,nvar,iclo,ichi,jclo,jchi,levc,1,1)
        endif
      else
        if (xperdom .or. yperdom) then
          call preicall(valc,auxc,mic,mjc,nvar,naux,iclo,ichi,jclo,
     &                  jchi,levc)
        else
          call icall(valc,auxc,mic,mjc,nvar,naux,iclo,ichi,jclo,jchi,
     &               levc,1,1)

        endif
      endif

      call bc2amr(valc,auxc,mic,mjc,nvar,naux,
     1            hxcrse,hycrse,levc,time,
     2            xl,xr,yb,yt,
     3            xlower,ylower,xupper,yupper,
     4            xperdom,yperdom)



c-----------------------------
c     # for shallow water over bathymetry,
c     # in coarse cells convert from h,
c     # to eta,  before interpolating:
c-----------------------------
      toldry = depthtolerance
c     #prepare slopes - use min-mod limiters
      do j=2, mjc-1
      do i=2, mic-1

       	dryflag=.false.
       	velocityflag=.false.

c     # coarse values surrounding the current coarse value are set
c     # These 9 cells are ordered as follows:
c     # left to right, and bottom to top
c     # This makes ic,jc the number 5 cell

        coarseval(1,1) = valc(i-1,j-1,1) + auxc(i-1,j-1,1)
        coarseval(2,1) = valc(i  ,j-1,1) + auxc(i  ,j-1,1)
        coarseval(3,1) = valc(i+1,j-1,1) + auxc(i+1,j-1,1)
        coarseval(4,1) = valc(i-1,j  ,1) + auxc(i-1,j  ,1)
        coarseval(5,1) = valc(i  ,j  ,1) + auxc(i  ,j  ,1)
        coarseval(6,1) = valc(i+1,j  ,1) + auxc(i+1,j  ,1)
        coarseval(7,1) = valc(i-1,j+1,1) + auxc(i-1,j+1,1)
        coarseval(8,1) = valc(i  ,j+1,1) + auxc(i  ,j+1,1)
        coarseval(9,1) = valc(i+1,j+1,1) + auxc(i+1,j+1,1)

        do ivar=2,nvar
               coarseval(1,ivar) = valc(i-1,j-1,ivar)
               coarseval(2,ivar) = valc(i  ,j-1,ivar)
               coarseval(3,ivar) = valc(i+1,j-1,ivar)
               coarseval(4,ivar) = valc(i-1,j  ,ivar)
               coarseval(5,ivar) = valc(i  ,j  ,ivar)
               coarseval(6,ivar) = valc(i+1,j  ,ivar)
               coarseval(7,ivar) = valc(i-1,j+1,ivar)
               coarseval(8,ivar) = valc(i  ,j+1,ivar)
               coarseval(9,ivar) = valc(i+1,j+1,ivar)
        enddo

	if (valc(i,j,1).le.toldry) then
	       etaav = 0.d0
	       coarseval(5,2) = 0.d0
	       coarseval(5,3) = 0.d0
	       wet=0.d0
	       do ip=-1,1
	       do jp=-1,1
	       	  if (valc(i+ip,j+jp,1).gt.toldry) then
		    	wet=wet+1.d0
		    	etaav=etaav+valc(i+ip,j+jp,1)
     &		    		+auxc(i+ip,j+jp,1)
		  endif
	       enddo
	       enddo
	       if (wet.gt.0.d0) etaav=etaav/wet
	       coarseval(5,1)=min(coarseval(5,1),etaav)
	 endif

c	# for ivar = 1.
	   ivar=1
c	==============x-slope=================================================
           slp = valc(i+1,j,ivar)-valc(i,j,ivar)
     &		     +auxc(i+1,j,ivar)-auxc(i,j,ivar)	      
           slm = valc(i,j,ivar)-valc(i-1,j,ivar)
     &		     +auxc(i,j,ivar)-auxc(i-1,j,ivar)

	   if (valc(i+1,j,1).gt.toldry.and.valc(i-1,j,1).gt.toldry) then
           	slopex = dmin1(dabs(slp),dabs(slm))*
     &            dsign(1.0d0,valc(i+1,j,ivar)-valc(i-1,j,ivar)
     &			+auxc(i+1,j,ivar)-auxc(i-1,j,ivar))
     	   elseif (valc(i+1,j,1).gt.toldry) then
	   	slopex = s1p
	   elseif (valc(i-1,j,1).gt.toldry) then
	   	slopex = s1m
	   else
	   	slopex = 0.d0
	   endif

c        # if there's a sign change, set slope to 0.
           if ( slm*slp .gt. 0.d0) then
             dudx(i) = slopex
           else
             dudx(i) = 0.d0
           endif


c=========y slope==========================================================
	   slp = valc(i,j+1,ivar)-valc(i,j,ivar)
     &		    +auxc(i,j+1,ivar)-auxc(i,j,ivar)
           slm = valc(i,j,ivar)-valc(i,j-1,ivar)
     &		    +auxc(i,j,ivar)-auxc(i,j-1,ivar)

	   if (valc(i,j+1,1).gt.toldry.and.valc(i,j-1,1).gt.toldry) then
           	slopey = dmin1(dabs(slp),dabs(slm))*
     &            dsign(1.0d0,valc(i,j+1,ivar)-valc(i,j-1,ivar)
     &			+auxc(i,j+1,ivar)-auxc(i,j-1,ivar))
	   elseif (valc(i,j+1,1).gt.toldry) then
	   	slopey = s1p
	   elseif (valc(i,j-1,1).gt.toldry) then
	        slopey = s1m
	   else
	   	slopey = 0.d0
	   endif

           if (slm*slp.gt.0.d0) then
             dudy(i) = slopey
           else
             dudy(i) = 0.d0
           endif


c     interp. from coarse cells to fine grid

c	#velocityflag if set to true, means that interpolation based on momentum
c	#might generate unreasonably large velocities.  In this case, the velocity
c	#in the fine cells is set to the value in the coarse cell and then, the depths
c	#in the fine cells determine the momentum.  This is conservative, if all fine cells have
c	#mass.

      	   do ico = 1,lratiox
           do jco = 1,lratioy

              yoff  = (float(jco) - .5)/lratioy - .5
	      xoff = (float(ico) - .5)/lratiox - .5
              jfine = (j-2)*lratioy + nghost + jco
              ifine   = (i-2)*lratiox + nghost + ico
              val(ifine,jfine,ivar) = coarseval(5,ivar)
     &                                + xoff*dudx(i) + yoff*dudy(i)

c	    # convert eta back to h
                val(ifine,jfine,1)=val(ifine,jfine,1)-aux(ifine,jfine,1)
		val(ifine,jfine,1)=dmax1(val(ifine,jfine,1),0.d0)
		if (val(ifine,jfine,1).lt.toldry) then
			velocityflag=.true.
		endif
	   enddo
	   enddo

c	==================velocity variables ===========================
	do ivar=2,nvar

c	=============x slope ===========================================
           slp = valc(i+1,j,ivar)-valc(i,j,ivar)	      
           slm = valc(i,j,ivar) - valc(i-1,j,ivar)

	   if (valc(i+1,j,1).gt.toldry.and.valc(i-1,j,1).gt.toldry) then
           	slopex = dmin1(dabs(slp),dabs(slm))*
     &            dsign(1.0d0,valc(i+1,j,ivar) - valc(i-1,j,ivar))
     	   elseif (valc(i+1,j,1).gt.toldry) then
	   	slopex = s1p
	   elseif (valc(i-1,j,1).gt.toldry) then
	   	slopex = s1m
	   else
	   	slopex = 0.d0
	   endif

c        # if there's a sign change, set slope to 0.
           if ( slm*slp .gt. 0.d0) then
             dudx(i) = slopex
           else
             dudx(i) = 0.d0
           endif

c	==========y slope ==============================================
	   slp = valc(i,j+1,ivar) - valc(i,j,ivar)
           slm = valc(i,j,ivar)   - valc(i,j-1,ivar)
	   if (valc(i,j+1,1).gt.toldry.and.valc(i,j-1,1).gt.toldry) then
           	slopey = dmin1(dabs(slp),dabs(slm))*
     &            dsign(1.0d0,valc(i,j+1,ivar) - valc(i,j-1,ivar))
	   elseif (valc(i,j+1,1).gt.toldry) then
	   	slopey = s1p
	   elseif (valc(i,j-1,1).gt.toldry) then
	        slopey = s1m
	   else
	   	slopey = 0.d0
	   endif

           if ( slm*slp .gt. 0.d0) then
             dudy(i) = slopey
           else
             dudy(i) = 0.d0
           endif

c	   # Determine the maximum and minimum coarse velocities in the area
              h=valc(i,j,1)
	      vel=0.d0
	      if (h.gt.0.d0)  vel=valc(i,j,ivar)/h
	      velmin=vel
	      velmax=vel
	      do ip=-1,1
	      do jp=-1,1
              	  h=valc(i+ip,j+jp,1)
	          vel=0.d0
	          if (h.gt.0.d0)  vel=valc(i+ip,j+jp,ivar)/h
		  velmin=min(velmin,vel)
	          velmax=max(velmax,vel)
	      enddo
	      enddo

c     interp. from coarse cells to fine grid

c	#velocityflag if set to true, means that interpolation based on momentum
c	#might generate unreasonably large velocities.  In this case, the velocity
c	#in the fine cells is set to the value in the coarse cell and then, the depths
c	#in the fine cells determine the momentum.  This is conservative, if all fine cells have
c	#mass.


      	   do ico = 1,lratiox
           do jco = 1,lratioy

              yoff  = (float(jco) - .5)/lratioy - .5
	      xoff = (float(ico) - .5)/lratiox - .5
              jfine = (j-2)*lratioy + nghost + jco
              ifine   = (i-2)*lratiox + nghost + ico
              val(ifine,jfine,ivar) = valc(i,j,ivar)
     &                                + xoff*dudx(i) + yoff*dudy(i)

	      if (val(ifine,jfine,1).le.toldry) then 
		  velocityflag=.true.
	      else
		 vel=val(ifine,jfine,ivar)/val(ifine,jfine,1)
		 if (vel.gt.velmax.or.vel.lt.velmin) velocityflag=.true.
	      endif

	   enddo
	   enddo

c	   # At this point all of the fine-cells are set.
c	   # If constantvel=true, then reset the momentum

	   if (velocityflag) then
	      hcoarse=valc(i,j,1)
              velcoarse=0.d0
              if (hcoarse.gt.0.d0) velcoarse=coarseval(5,ivar)/hcoarse
	      do ico = 1,lratiox
              do jco = 1,lratioy
                 yoff  = (float(jco) - .5)/lratioy - .5
	         xoff = (float(ico) - .5)/lratiox - .5
                 jfine = (j-2)*lratioy + nghost + jco
                 ifine   = (i-2)*lratiox + nghost + ico
		 val(ifine,jfine,ivar)=velcoarse*val(ifine,jfine,1)
	      enddo
	      enddo
	   endif
		
	enddo !end of ivar looping


      enddo	!end of coarse loop
      enddo	!end of coarse loop
c
c      if (mcapa .ne. 0) then
c        call fixcapaq(val,aux,mitot,mjtot,valc,auxc,mic,mjc,
c     &                nvar,naux,levc)
c      endif
c
c  overwrite interpolated values with fine grid values, if available.
c
      call intcopy(val,mitot,mjtot,nvar,ilo-nghost,ihi+nghost,
     &             jlo-nghost,jhi+nghost,lev,1,1)


      return
      end
