function mach = mach2(data)
% compute the Mach number from the data in 2 dimensions

gamma = 1.4;
rho = data(:,1);
u = data(:,2)./rho;
v = data(:,3)./rho;
speed2 = u.*u + v.*v;
p = (gamma-1) * (data(:,4) - 0.5*rho.*speed2);
c2 = (gamma*p./rho);
mach = sqrt(speed2 ./ c2);
